#include <stdio.h>

struct forder
{
	int cs;
};

%%{
	machine forder;
	variable curstate fsm->cs;

	m1 = ( "" %{printf("enter m1 aa\n");} |
			'aa'* >{printf("enter m1 aa\n");} %{printf("leave m1 aa\n");} )
		'b' @{printf("through m1 b\n");} . 'b'* . 'a'*;

	m2 = 'bbb'* 'aa'*;

	main := ( 
			m1 %{printf("accept m1\n");} |
			"" %{printf("enter m2\n");} |
			m2 >{printf("enter m2\n");} %{printf("accpet m2\n");}
		) . '\n';
}%%

%% write data;

void forder_init( struct forder *fsm )
{
	%% write init;
}

void forder_execute( struct forder *fsm, const char *_data, int _len )
{
	const char *p = _data;
	const char *pe = _data+_len;

	%% write exec;
}

int forder_finish( struct forder *fsm )
{
	%% write eof;

	if ( fsm->cs == forder_error )
		return -1;
	if ( fsm->cs >= forder_first_final )
		return 1;
	return 0;
}

#include <stdio.h>
#define BUFSIZE 2048

struct forder fsm;
char buf[BUFSIZE];

int main()
{
	forder_init( &fsm );
	while ( 1 ) {
		int len = fread( buf, 1, BUFSIZE, stdin );
		forder_execute( &fsm, buf, len );
		if ( len != BUFSIZE )
			break;
	}
	if ( forder_finish( &fsm ) > 0 )
		printf("ACCEPT\n");
	else
		printf("FAIL\n");
	return 0;
}

